package de.fsd.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.richfaces.model.Ordering;
import org.richfaces.model.selection.Selection;
import org.richfaces.model.selection.SimpleSelection;

import de.fsd.domain.ColumnConfigurationVO;
import de.fsd.domain.ConfigurationVO;
import de.fsd.service.ConfigurationServiceImpl;
import de.fsd.service.DatabaseServiceImpl;

/**
 * This class is the control for the searchModul
 * @author eugenbesel
 * www.besel-it.de
 */
public class SearchModulBBean {
	
	private List<ArrayList<String>> dataList = new ArrayList<ArrayList<String>>();
	ConfigurationVO confVO;
	private Object tableState;
	private Selection selection = new SimpleSelection();
	private Map<String, Ordering> sortOrders = new HashMap<String, Ordering>();
	private Map<String, Object> columnFilterValues = new HashMap<String, Object>();

	public Map<String, Object> getColumnFilterValues() {
		return columnFilterValues;
	}

	public void setColumnFilterValues(Map<String, Object> columnFilterValues) {
		this.columnFilterValues = columnFilterValues;
	}

	public Map<String, Ordering> getSortOrders() {
		return sortOrders;
	}

	public void setSortOrders(Map<String, Ordering> sortOrders) {
		this.sortOrders = sortOrders;
	}

	
	public SearchModulBBean(){
		init();
	}
	
	/**
	 * initialization of data. set default sort criteria
	 */
	public void init(){
		ConfigurationServiceImpl conf = new ConfigurationServiceImpl();
		confVO = conf.getConfiguration();
		DatabaseServiceImpl service = new DatabaseServiceImpl();
	    dataList = service.getValuesFromDatabase(confVO);
	    for(ColumnConfigurationVO columnsIter : confVO.getColumns()){
			if("true".equals(columnsIter.getSortselected())){	
				if(sortOrders.get(columnsIter.getCaption())==null){
					sortOrders.put(columnsIter.getCaption(), Ordering.ASCENDING);
				}else{
					
				}
			}
			
			
		}
	}
	
	public String getTableHeader(){
		return confVO.getTitel();
	}

	
	/**
	 * this method create the data values for displaing n GUI 
	 * @return
	 */
	public List<ArrayList<String>> getColumnData(){
		
		return dataList;
	}
	public Object getTableState() {
		return tableState;
	}

	public void setTableState(Object tableState) {
		this.tableState = tableState;
	}

	public Selection getSelection() {
		return selection;
	}

	public void setSelection(Selection selection) {
		this.selection = selection;
	}
	
	public boolean filterData(Object current) {
		if(current==null){
			return false;
		}
		List<String> filterData = (ArrayList<String>)current;
		if(!columnFilterValues.keySet().isEmpty()){
			Iterator<String> iter = columnFilterValues.keySet().iterator();
			int columnIndex=0;
			while(iter.hasNext()){
				String key = iter.next();
				String data = (String)columnFilterValues.get(key);
				filterData.get(columnIndex).equals(data);
			}
		}
//		System.out.println(current.toString());
		return true;
	}
	
	public String getColumnCount(){
		int columnIndex=0;
		if(!columnFilterValues.keySet().isEmpty()){
			Iterator<String> iter = columnFilterValues.keySet().iterator();
			
			while(iter.hasNext()){
				columnIndex++;
				iter.next();
			}
	   }
		return columnIndex+"";
	}
	
	
	/**
	 * this method create the Array for Columns
	 * @return
	 */
	public List<String> getColumns(){
		List<String> columns = new ArrayList<String>();
		for(ColumnConfigurationVO columnsIter : confVO.getColumns()){
			columns.add(columnsIter.getCaption());
		}
		
		return columns;
	}
	
	/*
	public void takeSelection(){
		selectedCapitals.clear();
		Iterator<Object> iterator = getSelection().getKeys();
		while (iterator.hasNext()) {
			Object key = iterator.next();
			selectedCapitals.add(getCapitalsDataModel().getObjectByKey(key));
		}
	}*/
}
